#ifndef __BIAWEBUTIL__
#define __BIAWEBUTIL__
#include <string>

// utility functions for Biaweb that don't fit into any class and can be used by 
// any class
namespace biaweb {
    // convert a document title to a file title - strip out the non-alpha
    // chars and spaces
    std::string convert_title (std::string title)
    {
        std::string output;
        for (char c : title) {
            if (isalnum (c))
                output.append (1, c);
            else if (isspace (c))
                output.append (1, '_');
        }
        return output;
    }

    // escape HTML special characters 
    std::string escape_html (std::string source)
    {
    	std::string replace_buf;
        replace_buf.reserve (source.size());
        for (char p : source)
        {
            switch (p)
            {
                case '&' : replace_buf.append ("&amp;"); break;
                case '<' : replace_buf.append ("&lt;"); break;
                case '>' : replace_buf.append ("&gt;"); break;
                case '\"': replace_buf.append ("&quot;"); break;
                case '\'': replace_buf.append ("&apos;"); break;
                default  : replace_buf.append (1, p); 
            }
        }
        return replace_buf;
    }
}
#endif